<html>
<body>
<h1> Triangulated Rubber Band Sketch </h1>

<p>
Update: it turned out there is a <a href="fail.html">case</a> that TRBS
can not handle so it can not be used for the toporouter.

<h2> I. Rationale </h2>

<h2> II. Context </h2>
<p>
netlist -&gt; LAA -&gt; NORD -&gt; TRBS -&gt; embed geometry
<p>
The Layer Assignment Algorithm (LAA) receives the netlist of the input
board and breaks down the routing problem into independent, single layer
routing problems by assigning network segments (2nets) to specific
layers. All vias, with their final coordinates, are added in this step.
By using multiple layers the LAA resolves many net-net crossings. For
various reasons some of the crossings will be left in the output, and
those crossings will need to be resolved by on-layer detours.
<p>
The output of the LAA, per layer, is an unordered list of 2nets. A 2net
is described by its two fixed endpoints (vertices) in the 2d space. The
Network Ordering (NORD) step orders the list so that networks with more
direct, more straight-line connections (less detour) come first.
<p>
The next step, the Triangulated Rubber Band Sketch router (TRBS)
will route 2nets one by one, in the exact order the NORD specified. If a 2net
being routed would cross a 2net already routed, the current 2net needs to
make detour. The TRBS considers multiple detours trying to find the shortest.
If there is no route possible, the TRBS changes the net ordering and tries
again.
<p>
	<center>
	<p><br>&nbsp;<br>&nbsp;
	<p><img src="tri.png" alt="triangulation" width="500px">
	<p><i>Figure 1: triangulation; grey lines are triangle edges; yellow lines
	   are three 2nets to route</i>
	<p><br>&nbsp;<br>&nbsp;
	</center>
<p>
The TRBS performs these operations on a mixed model: it takes the input
geometry (vias, obstacles, board size) and triangulates it (Figure 1). The triangulation
yields <b>vertices</b> (at obstacles) and <b>edges</b> that connect the vertices
and <b>triangles</b> (defined by 3 vertices or 3 edges).
<p>
2nets are routed on a <b>path</b> from a starting vertex through edge crossings until it
reaches the ending vertex (Figure 2). Paths are abstract, topological: the exact
coordinates of the 2nets are not considered, only the order of 2net-edge crossings.
<p>
	<center>
	<p><br>&nbsp;<br>&nbsp;
	<p><img src="path.png" alt="path example" width="500px">
	<p><i>Figure 2: two possible paths (blue and green) connecting 2net starting
	      vertex S with ending vertex T; path-edge crossings are indicated with
	      red X marks</i>
	<p><br>&nbsp;<br>&nbsp;
	</center>
<p>
Furthermore each 2net has a required geometry (wire thickness and
clearance), and edges have physical lengths. Local congestion is avoided by
refusing routing a 2net across an edge if the edge ran out of capacity - in
which case an alternate (longer) detour is searched or ultimately network
ordering is changed.
<p>
Finally, of the TRBS finished routing (Figure 3), the result is a list of topological edge
crossing for each triangulation edge for each 2net on its way between its
start and end vertex. The last step is translating these crossings back
to physical geometry, introducing new edges (spokes) and moving the
2net-edge crossing points on the edge without changing the order of them.
<p>
	<center>
	<p><br>&nbsp;<br>&nbsp;
	<p><img src="3net.png" alt="three nets routed" width="500px">
	<p><i>Figure 3: three networks (blue) routed by this algorithm; first the two horizontal ones then
	   the vertical one</i>
	<p><br>&nbsp;<br>&nbsp;
	</center>
<p>
This document focuses on the TRBS step.

<h2> III. TRBS data model </h2>
<p>
The central data structure describes a <b>crossing</b> of a 2net and an edge.
Each crossing is collected in two ordered doubly linked lists:
<ul>
	<li> on the 2net's <b>path</b> list, as crossings describe the topological path
	     the 2net is routed on
	<li> on the edge's list, as the crossings on the edge describe the order of
	     2nets
</ul>
<p>
There are no restrictions on the number of crossings: any number of
2nets may cross an edge (as long as the capacity of the edge can take the
2nets, i.e. length of the edge justifies the total space taken up by 2net
wire thicknesses and clearances). Walking the path of a 2net, there can
be any number of crossings, from zero up, but any time the 2net is crossing
a triangulation edge, there must be a crossing created.
<p>
Note: multiple crossing points of the same 2net-edge can occur, as shown on
Figure 3.
	<center>
	<p><br>&nbsp;<br>&nbsp;
	<p><img src="uturn.png" alt="repeated crossings" width="500px">
	<p><i>Figure 3: the blue net between A and B need to make detours around
	      other (blue) nets. On the way, it crosses some edges (marked with red)
	      twice, at different locations. Blue nets are routed by this algorithm</i>
	<p><br>&nbsp;<br>&nbsp;
	</center>
<p>
Each <b>2net</b> is specified by a starting and an ending triangulation
vertex and an ordered doubly linked list of crossings. Which
terminal/via is the starting vertex and which terminal/via is the ending
vertex is an arbitrary choice of the LAA, but once the choice is made, it
is not changed.
<p>
In the triangulation each <b>edge</b> is connected to two vertices, has
a known physical length and holds an ordered list of crossing from vertex 1 to
vertex 2. Which triangulation vertex is called 1 is an arbitrary choice made
during triangulation (and never changed later).

<h2> IV. TRBS algorithm: path finding </h2>
<p>
A 2net is always starting from a vertex, will cross zero or more edges (last
edge being part of the triangle with the ending vertex), then will connect
to the ending vertex. This path can be searched using the A* algorithm, on
a graph formed by these rules:
<ul>
	<li> <b>case S</b>: start is the 2net starting vertex; if a neighbor vertex is the ending
	     vertex of the 2net, and the edge connecting the two vertices doesn't
	     have any crossing, the path is found (that edge, with zero crossing).
	     Else neighbor nodes for A* are the opposite edge of each triangle the
	     starting vertex is part of. (See Figure 5/a.)
	<li> <b>case T</b>: After an edge crossing, if the triangle (the path just arrived into)
	     contains the ending vertex, the path is complete. (See Figure 5/b.)
	<li> <b>case E</b>: Else jump from edge to edge: A* neighbor nodes are the other two
	     edges of the triangle the path arrived into by the last edge crossing.
	     Go on searching for the path. (See Figure 5/c.)
</ul>
<p>
	<center>
	<p><br>&nbsp;<br>&nbsp;
	<p><img src="astar.png" alt="A* path finding examples" width="700px">
	<p><i>Figure 5: path finding with A*;
		<br>a.: case S: start from vertex S, potential next graph nodes are the
		        vertices marked with red arrows (assuming T is not on any neighbor
		        vertex on this drawing)
		<br>b.: thick blue line is the path crossing the left edge of a triangle;
		        since the triangle contains the end vertex T, the only one next node
		        is T and the path is completed (thin blue line).
		<br>c.: thick blue line is the path crossing the left edge of a triangle;
		        since T is not in the triangle, there are two possible ways the path
		        could continue (thin blue lines); the two affected edges 
		        (marked with red arrows) are the potential next nodes of the A* search graph
		</i>
	<p><br>&nbsp;<br>&nbsp;
	</center>
<p>
There are two reasons for excluding the next node from the A* search:
<ul>
	<li> if the next node is an edge crossing and remaining edge capacity is smaller
	     than required by the current 2net's routing style
	<li> there's no straight-line visibility from the current edge to the target
	     edge or target vertex within the triangle (it is blocked by a 2net
	     placed earlier); visibility is calculated as described below, in
	     section V.
</ul>
<p>
The cost function is path length assuming edge crossing points are located
at where they result in the shortest path, ignoring wire widths and
clearances. The heuristic function is the distance to the 2net's ending vertex.


<h2> V. TRBS algorithm: query in-triangle visibility </h2>
<p>
The path is entering a triangle from a vertex or from a specific point on
an edge. Point on an edge is in the topological sense, not in the
geometrical sense: all points between two existing crossing or edge
endpoint are the same. Main input is the enter point or vertex.
Other input is a target edge (see Figure 5/c, marked with red arrows)
or target vertex within the same triangle (see Figure 5/b, T).
<p>
	<center>
	<p><br>&nbsp;<br>&nbsp;
	<p><img src="passthru1.png" alt="in-triangle visibility algorithm" width="500px">
	<p><i>Figure 6: edge-to-edge visibility in a triangle; annotations are
	   drawn with red, existing paths (routed with this algorithm) are drawn with blue</i>
	<p><br>&nbsp;<br>&nbsp;
	</center>
<p>
In case of target edge, the output is a point on that edge (which topologically
means the index on the edge's crossing list, where the new crossing is to be
inserted between edge end vertices or existing crossings). In case of target
vertex, the output is a boolean, whether that vertex is visible or not.
<p>
The algorithm for determining visibility (e.g. on Figure 6) is:
<p>
<ul>
	<li> 1. start walking the triangle (edge) from the entering point in
	     one direction, e.g. CCW
	<li> 2. move along an edge until a crossing or vertex is detected
	<li> 3. if vertex:
	<ul>
		<li> 3a. if it is the target vertex, return true
		<li> 3b. else check if any path is starting from the vertex into the
		         current triangle; if so, go on tracing along that path
		         (go to step 4)
		<li> 3c. else take the next edge from that vertex in the same triangle;
		         if that is the target edge, return as in 4a, else go on tracing
		         (go to step 5)
	</ul>
	<li> 4. if crossing: from the crossing, follow the path crossing the current triangle:
	<ul>
		<li> 4a. if it lands in a vertex, continue on the next edge in the chosen direction:
		     if that is the target edge, return the result (index is either 0 or
		     length-of-crossing-list, depending on which vertex the path has hit);
		     if not the target edge, else continue with step 5
		<li> 4b. if it lands on an edge: if the edge is the target edge, the result
		     is the next (or previous) index  after (or before) the crossing,
		     else continue with step 5
	</ul>
	<li> 5. if the tracing is back to the same edge or vertex it started from,
	     there is no visibility, return failure. Else go on tracing
	     (go to step 2).
</ul>

<h2> VI. TRBS algorithm: example cases </h2>
<p> Case 1:
path (green) going out from a vertex of the current triangle does not
change the result of the visibility test:
<p>
	<center>
	<p><br>&nbsp;<br>&nbsp;
	<p><img src="passthru2.png" alt="visibility example in a triangle" width="500px">
	<p><i>Figure 7: blue and green nets (routed by this algorithm) starting from triangle vertices, still
	      S2 finds its target edge point</i>
	<p><br>&nbsp;<br>&nbsp;
	</center>
<p>
On Figure 7, a CW search from S2 first reaches vertex PA then will jump to the edge PA-PC,
which is the target edge.

<p> Case 2:
On Figure 7, tracing CCW from S2: because of 3b., the search reaches target edge after
tracing S2's edge, vertex PB and the blue path.

<p> Case 3: visibility blocked
<p>
	<center>
	<p><br>&nbsp;<br>&nbsp;
	<p><img src="passthru3.png" alt="visibility blocked in a triangle" width="500px">
	<p><i>Figure 8: target edge not visible from S2 because of an existing path</i>
	<p><br>&nbsp;<br>&nbsp;
	</center>
<p>
On Figure 8, starting from S2, tracing CCW: trace S2's edge to PB, then switch edge
by 3c, bumping into the blue path by 4, tracing it to edge PA-PB;
this edge is the edge S2 is on. By 5, return failure.
